//+------------------------------------------------------------------+
//|                                                       FastZZ.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Yurich"
#property link      "https://login.mql5.com/ru/users/Yurich"
//---
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Red
//--- input parameters
extern int Depth=300;
//---
double zzH[], zzL[];
double depth;
int last, direction, pbars;
datetime lastbar;
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   SetIndexBuffer(0,zzH);
   SetIndexBuffer(1,zzL);
   SetIndexStyle(0,DRAW_ZIGZAG);
   SetIndexStyle(1,DRAW_ZIGZAG);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   IndicatorDigits(Digits);
//----
   depth=Depth*Point;
   direction=1;
   last=0;
   pbars=0;
   lastbar=0;
   return(0);
}
//+------------------------------------------------------------------+
int start()
{
   int start=Bars-IndicatorCounted()-1;
   if(lastbar!=Time[0])
   {
      lastbar=Time[0];
      last++;
   }
   if(MathAbs(Bars-pbars)>1) { last=Bars-1; start=last;}
   pbars=Bars;
   //---
   for(int i=start; i>0; i--)
   {
      bool set=false;
      zzL[i]=0;
      zzH[i]=0;
      //---
      if(direction>0)
      {
         if(High[i]>zzH[last])
         {
            zzH[last]=0;
            zzH[i]=High[i];
            if(Low[i]<High[last]-depth)
            {
               if(Open[i]<Close[i]) zzH[last]=High[last]; else direction=-1;
               zzL[i]=Low[i];
            }
            last=i;
            set=true;
         }
         if(Low[i]<zzH[last]-depth && (!set || Open[i]>Close[i]))
         {
            zzL[i]=Low[i];
            if(High[i]>zzL[i]+depth && Open[i]<Close[i]) zzH[i]=High[i]; else direction=-1;
            last=i;
         }
      } else //direction<0
      {
         if(Low[i]<zzL[last])
         {
            zzL[last]=0;
            zzL[i]=Low[i];
            if(High[i]>Low[last]+depth)
            {
               if(Open[i]>Close[i]) zzL[last]=Low[last]; else direction=1;
               zzH[i]=High[i];
            }
            last=i;
            set=true;
         }
         if(High[i]>zzL[last]+depth && (!set || Open[i]<Close[i]))
         {
            zzH[i]=High[i];
            if(Low[i]<zzH[i]-depth && Open[i]>Close[i]) zzL[i]=Low[i]; else direction=1;
            last=i;
         }
      }
   }
//----
   zzH[0]=0;
   zzL[0]=0;
//----
   return(0);
}
//+------------------------------------------------------------------+